#INCLUDE "RTF.H"

Set Proc To MAKE_RTF.PRG
Local lcFname

=SampleRTF(.T.,"cursor.sab")

 DECLARE Integer RunRep  IN genrep.dll AS Runr String @cName, Integer Isd
 DECLARE Integer RunDial IN genrep.dll AS Rund String @cName, Integer Isd

 =Runr('cursor.sab' , 0+1)



***********************************
***********************************
Func SampleRTF(bWordStart_, cFileName_)
  oFile = CreateObject("CRtfFile", cFileName_,.T.)
  With (oFile) 
   .DefaultInit
   .WriteHeader
   .PageA4
     
   .WriteParagraph("[<cursor.dbf]",raLeft,rfsDefault, 0, 0, 3, 24)

   .WriteParagraph("", raLeft, rfsBold, 0, 0, 2, 24)
   .WriteParagraph("    .",raCenter, rfsBold+rfsItalic, 0, 0, 3, 32)
   .WriteParagraph("", raLeft, rfsBold, 0, 0, 2, 24)
   .SetAlignment(raCenter)

   .BeginTable                           &&  
   .SetColumnsCount(3)
   .m_arTblWidths(1) = .Twips(7)         &&   (  - )
   .m_arTblWidths(2) = .Twips(4)         &&   (  - )
   .m_arTblWidths(3) = .Twips(5)
   .SetFont(3, 20, rfsBold)
   .SetupColumns()
   .m_arTblValues(1) = ""    
   .m_arTblValues(2) = ""
   .m_arTblValues(3) = ""
    For i = 1 To 3
      .m_arTblAlign(i) = raCenter
    Next i
   .WriteRow()                           &&   .m_arTblValues   
   .EndTable

   .WriteParagraph("[<Detal]",raLeft,rfsDefault, 0, 0, 3, 24)

   .SetFont(3, 18, rfsDefault)
   .BeginTable                           &&  
   .SetColumnsCount(3)
   .m_arTblWidths(1) = .Twips(7)         &&   (  - )
   .m_arTblWidths(2) = .Twips(4)         &&   (  - )
   .m_arTblWidths(3) = .Twips(5)
   .SetupColumns()
   .m_arTblAlign(1) = raLeft
   .m_arTblAlign(2) = raRight
   .m_arTblAlign(3) = raCenter
   .m_arTblValues(1) = "[English_na]"
   .m_arTblValues(2) = "[Unit_price]"
   .m_arTblValues(3) = "[Quantity_i]"
   .WriteRow()               &&   .m_arTblValues   
   .EndTable

   .SetFont(3, 18, rfsDefault)
   .WriteParagraph("[Detal>]",raLeft,rfsDefault, 0, 0, 3, 24)  
   .WriteParagraph("[cursor.dbf>]",raLeft,rfsDefault, 0, 0, 3, 24)
   .CloseFile 
  EndWith    

Return
